#include "DribbleAnalyzer.h"

#include "Analyzer.h"
#include "Grid.h"

#include "../basic/Timer.h"
#include "../worldmodel/WorldModelInterface.h"
#include "../worldmodel/Situation.h"

DribbleAnalyzer::DribbleAnalyzer() {
  theDribbleTarget = Vector(0,0);
}

void DribbleAnalyzer::calculateValues()
{
  double dir, length;

  if( globalWorldModel->id() <= 423 ) { // Stuermer
    if( globalWorldModel->player().pos().x() < 30.0 ) {
      dir = 0.0;
      length = 10;
    }
    else {
      dir = globalWorldModel->preferredKickDirection(globalWorldModel->player().pos()).angle();
      length = 10;
    }
  }
  else if( globalWorldModel->id() <= 426 ) { // Mittelfeld
    dir = globalWorldModel->preferredKickDirection(globalWorldModel->player().pos()).angle();
    length = 20;
  }
  else {                                      //Verteidiger
    length = 50;
    dir = 0.0;
//    dir = globalWorldModel->preferredKickDirection(globalWorldModel->player().pos()).angle();

  }


  theDribbleTarget = globalWorldModel->player().pos() + Vector( length, dir, POLAR, RADIAN);
}
