#ifndef _GOAL_KICK_AFTER_CATCH_POSITION_ANALYZER_H_
#define _GOAL_KICK_AFTER_CATCH_POSITION_ANALYZER_H_

#include "PassAnalyzer.h"

#include "../intentions/targets/Target.h"

class GoalKickAfterCatchPositionAnalyzer:public PassAnalyzer {
  public:
    GoalKickAfterCatchPositionAnalyzer();
    void calculateValues();
    const Vector& getGoalKickAfterCatchPositionTarget();
    const Vector& getGoalKickAfterCatchPassTarget();
    const bool isGoalKickAfterCatchPossible();
    const int getGoalKickAfterCatchPassReceiverId();

  protected:
    void setGoalKickAfterCatchPositionTarget( Vector v );
    void setGoalKickAfterCatchPassTarget( Vector v );
    Vector goalKickAfterCatchPositionTarget;
    Vector goalKickAfterCatchPassTarget;
    bool goalKickAfterCatchPossible;
	void setGoalKickAfterCatchPossible( bool b );
	void setGoalKickAfterCatchPassReceiverId( int i );
	int passReceiverId;
	int catchCount;
	int moveCount;
};


inline void GoalKickAfterCatchPositionAnalyzer::setGoalKickAfterCatchPositionTarget( Vector v )
{
  goalKickAfterCatchPositionTarget = v;                                                                      		
}

inline void GoalKickAfterCatchPositionAnalyzer::setGoalKickAfterCatchPassTarget( Vector v )
{
  goalKickAfterCatchPassTarget = v;                                                                      		
}

inline void GoalKickAfterCatchPositionAnalyzer::setGoalKickAfterCatchPossible( bool b )
{
  goalKickAfterCatchPossible = b;		
}

inline void GoalKickAfterCatchPositionAnalyzer::setGoalKickAfterCatchPassReceiverId( int i )
{
  passReceiverId = i;		
}

inline const bool GoalKickAfterCatchPositionAnalyzer::isGoalKickAfterCatchPossible()
{
  return goalKickAfterCatchPossible;		
}	
#endif
