#include <string>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>

#include "Ath98String.h"

/**
 * Aktueller Stand
 *
 *   $RCSfile: Ath98String.cc,v $
 *   $Revision: 1.1.1.1 $
 *   $Date: 2001/07/31 22:23:08 $
 *   $Author: rami $
 *
 */

Ath98String::Ath98String( const char *newValue )
{
  len = strlen( newValue );
  value = new char[len + 1];  // +1 fuer \0 am Ende
  strcpy( value, newValue );
}

Ath98String::Ath98String( const int newValue )
{
  char tmpValue[20];

  sprintf( tmpValue, "%i", newValue );
  len = strlen( tmpValue );
  value = new char[len + 1];
  strcpy( value, tmpValue );
}


Ath98String::Ath98String( const long newValue )
{
  char tmpValue[20];

  sprintf( tmpValue, "%ld", newValue );
  len = strlen( tmpValue );
  value = new char[len + 1];
  strcpy( value, tmpValue );
}

Ath98String::Ath98String( const double newValue )
{
  char tmpValue[25];

  sprintf( tmpValue, "%g", newValue );
  len = strlen( tmpValue );
  value = new char[len + 1];
  strcpy( value, tmpValue );

}

Ath98String::Ath98String( const bool newValue )
{
  char tmpValue[25];

  if( newValue == YES )
    strcpy( tmpValue, "YES" );
  else
    strcpy( tmpValue, "NO" );
  len = strlen( tmpValue );
  value = new char[len + 1];  
  strcpy( value, tmpValue );    
 
} 
 
Ath98String::Ath98String( const Ath98String& s ) 
{ 
  len = s.len;  
  value = new char[ len+1 ];  
  strcpy( value, s.value );    
 
} 
 
Ath98String::Ath98String( int newLen, char a ) 
{ 
  len = newLen;  
  value = new char [len+1];  
  a = a;  
} 
 
 
const Ath98String& Ath98String::operator= ( const Ath98String& s ) { 
 
  if ( this == &s ) { 
    return *this;  
  } 
   
  if ( len < s.len ) { 
    delete [] value;  
    value = new char [s.len + 1];  
  } 
 
  strncpy( value, s.value, s.len + 1 );  
  len = s.len;  
   
  return *this;   
} 
 
 
Ath98String operator+ ( const Ath98String& s1, const Ath98String& s2 )
{
  Ath98String sum( s1.len + s2.len, 'a' );    
  strcpy( sum.value, s1.value );  
  strcat( sum.value, s2.value );  
  return sum;  
   
} 
 
Ath98String Ath98String::leftString( int charCount ) const 
{ 
  if ( charCount < 0 ) { 
    charCount = 0;  
  } 
  else if ( charCount > len ) { 
    charCount = len;  
  } 
  Ath98String result(charCount, 'd');  
  strncpy(result.value, value, charCount);  
  result.value[charCount] = '\0';  
  return result;  
} 
   
Ath98String Ath98String::rightString( int charCount ) const 
{ 
  if ( charCount < 0 ) { 
    charCount = 0;  
  } 
  else if ( charCount > len ) { 
    charCount = len;  
  } 
  return subString( len-charCount, charCount );  
} 
 
Ath98String Ath98String::subString( int leftIndex, int charCount = UNDEF_INT ) const 
{ 
  if ( leftIndex < 0 ) { 
    leftIndex = 0;  
  } 
  else if ( leftIndex > len ) { 
    leftIndex = len;  
  }
   
  if ( charCount == UNDEF_INT ) { 
    charCount = len - leftIndex;  
  } 
  else if ( charCount < 0 ) { 
    charCount = 0;  
  }  
  else if ( leftIndex+charCount > len ) { 
    charCount = len-leftIndex;  
  } 
 
  Ath98String result(charCount, 'd');  
  strncpy(result.value, value+leftIndex, charCount);  
  result.value[charCount] = '\0';  
  return result;  
} 
 
int Ath98String::asInt() const  
{ 
  int result = 0;  
  if ( len > 0 ) { 
    result = atoi( value );  
  } 
  return result;  
}

Ath98String* Ath98String::copy() const {
  return new Ath98String( *this );
}

Ath98String Ath98String::toString() const
{
  return *this;
}



Ath98String::~Ath98String()
{
  delete [] value;
}
 
 
 
 
 
;  
