#ifndef _DELIBERATOR_H_
#define _DELIBERATOR_H_

#include <string>
#include <vector>

#include "../intentions/roles/StandardGoalieRole.h"
#include "../intentions/roles/StandardRole.h"

/**
  Die Entscheidungskomponente des Agenten.

  {\small {\bf Quelltext}

  [\URL[Header]{src/Deliberator.h} | [\URL[Implementierung]{src/Deliberator.cc}]

  {\bf CVS Informationen zum Interface}
  \begin{verbatim}
  **************************************************
  *
  * Aktueller Stand
  *
  *   $RCSfile: Deliberator.h,v $
  *   $Revision: 1.1.1.1 $
  *   $Date: 2001/07/31 22:23:08 $
  *   $Author: rami $ 
  *
  **************************************************
  \end{verbatim} }*/
class Deliberator
{
public:
  /** Konstruktor uebernimmt den Effektor.
    Es werden alle moeglichen Wuensche und alle moeglichen (sinnvollen)
    Nebenbedingungen verwendet. */
  Deliberator();



  /** Ausgabe auf StampStream */
  void toStampStream( ostream& ) const;
    /** Destruktor. */
  ~Deliberator();

  /** Berechnung der aktuellen Aktion. */
  Action execute();
  /** Initialisierung. */
  void initialize();

  /** Das Nachdenken. */
  void deliberate();

private:
  /** Private Fehlerklasse, die in indexOfBestDesire ausgeloest wird. */
  /** String der die Kurzkennung der Klasse enthlt */
  string theIdString;

  Role* theRole;

  /** Liefert einen String mit Klassenbezeichnung zurueck. */
  string idString() const;
 
};

inline string Deliberator::idString() const 
{ 
  return theIdString;  
} 
 
inline void Deliberator::toStampStream( ostream& os) const {

}


#endif

