/** 
 * Aktueller Stand 
 * 
 *   $RCSfile: Exception.cc,v $ 
 *   $Revision: 1.1.1.1 $ 
 *   $Date: 2001/07/31 22:23:08 $ 
 *   $Author: rami $  
 * 
 */ 
 
#include "Exception.h" 
#include "Ath98String.h" 
 
Ath98String *Exception::theFileName = NULL;  
int Exception::theLineNumber = 0;  
Ath98String *Exception::theDescription = NULL;  
  
Exception::Exception() 
{ 
  if ( theDescription != NULL ) { 
    delete theDescription;  
  }  
  theDescription = NULL;
} 
 
Exception::Exception(const Ath98String& aDescription)  
{ 
  if ( theDescription != NULL ) { 
    delete theDescription;  
  }  
  theDescription = new Ath98String( aDescription );  
 
} 
 
inline void Exception::resetFileName() 
{ 
  if ( theFileName != NULL ) { 
    delete theFileName;  
    theFileName = NULL;  
  }    
} 
 
Exception::~Exception() { 
//   if ( theDescription != NULL ) { 
//     delete theDescription;  
//     theDescription = NULL;  
//   } 
} 
 
void Exception::setDescription(const Ath98String& aDescription ) 
{ 
  if ( theDescription != NULL ) { 
    delete theDescription;  
  }    
  theDescription = new Ath98String( aDescription );    
} 
 
void Exception::setFileName(const Ath98String& fileName ) 
{ 
  resetFileName();  
  theFileName = new Ath98String( fileName );    
} 
 
void Exception::setLineNumber( int lineNumber ) 
{ 
  theLineNumber = lineNumber;    
} 
 
const Ath98String Exception::description() const 
{ 
  if ( theDescription != NULL ) { 
    return Ath98String( *theDescription );  
  } 
  else { 
    return Ath98String( "No description" );  
  } 
} 
 
const Ath98String Exception::toString() const 
{ 
  Ath98String output = Ath98String( "( Exception " );  
  output = output + "'" + description() + "'";  
 
  if ( theFileName != NULL && theLineNumber != 0 ) { 
    output = output + ", thrown at " + *theFileName + ", line " +  
      Ath98String( theLineNumber );  
  } 
  output = output + " )";      
  return output;  
} 
 
void Exception::printOn (ostream& anOutputStream ) const 
{ 
  anOutputStream << toString().cString();  
}   
