#ifndef _COMMON_COACH_H_
#define _COMMON_COACH_H_

/*
 * Aktueller Stand
 *
 *   $RCSfile: CommonCoach.h,v $
 *   $Revision: 1.4 $
 *   $Date: 2001/08/02 11:36:31 $
 *   $Author: wendler $ 
 * */


/**@name Objekt-Ids
  Objekt-Ids identifizieren in der Aussenwelt vorkommende Objekte wie Flaggen,
  Linien, Tore, Spielfeldseiten, Ball, Spieler (und auch
  etwas abstraktere Ideen wie Mannschaft) eindeutig.
  
  Zu jeder Gruppe von Ids, die gleichartige Objekte xxx beschreibt, gibt es
  eine MIN_xxx_ID und eine MAX_EXISTING_xxx_ID. Liegt eine Objekt-Id numerisch
  zwischen diesen beiden Konstanten (einschliesslich, also mit <= / >=
  vergleichen) , ist es eine gueltige Id fuer ein existierendes Objekt.
  Ausserdem gibt es noch allgemeinere Konstanten fuer die Art des Objekts
  (xxx_ID), fuer ein undefiniertes Objekt dieser Art (UNDEX_xxx_ID) und eine
  absolute obere Grenze MAX_xxx_ID. xxx_ID und UNDEX_xxx_ID sind garantiert <=
  MAX_xxx_ID. */
//@{
  /**@name Coach Identifikation */
  //@{
    const int COACH_NUM = 0;
  //@}
//@}

/**@name Record-Files Versionen */
//@{
  const int REC_OLD_VERSION = 1;
  const int REC_VERSION_2 = 2;
  const int REC_VERSION_3 = 3;
  const int DEFAULT_REC_VERSION = REC_VERSION_2;
//@}

int playerNumberById( int id );

#endif


