
/*
 * Aktueller Stand
 *
 *   $RCSfile: EffectorsRecord.cc,v $
 *   $Revision: 1.3 $
 *   $Date: 2001/08/02 11:49:02 $
 *   $Author: wendler $ 
 *
 */
 
#include "EffectorsRecord.h"
#include "../../basic/Log.h"
#include "../../basic/InvalidIdException.h"

EffectorsRecord::EffectorsRecord()
  : Effectors()
{
  theIdString = "EffectorsRecord";
}

EffectorsRecord::~EffectorsRecord()
{
}

void EffectorsRecord::enterField( const Ath98String& aTeamName ) const 
{
  //cout << "Entering field" << endl;
  // to fill with INFO
}

void EffectorsRecord::openEyes() const 
{
  //cout << "Opening Eyes" << endl;
  // to fill with INFO
}

void EffectorsRecord::changePlayerType(int playerNum, int type ) const
{
  if( playerNum < 1 || playerNum > 11 ) {
    throwException( InvalidIdException( "Invalid player number given." ) );
  }
  if( type < 0 || type >= 7 ) { //7 ersetzen durch globalConf->playerTypes
    throwException( InvalidIdException( "Invalid exchange type given." ) );
  }
  INFO( Log::SENSORS, 2, idString(), globalLog->infoStream <<
        "Imitating: (change_player_type " << playerNum << " " << type <<
        ")\n" );
}

void EffectorsRecord::sayMessage( const Ath98String& message ) const
{
  INFO( Log::SENSORS, 2, idString(), globalLog->infoStream <<
        "Imitating: (say " << message << ")\n" );
}
