#ifndef _EFFECTORS_SERVER_H_
#define _EFFECTORS_SERVER_H_

#include "./Effectors.h"
#include "../../serverInterface/Communicator.h"

/**
  Diese Klasse ist f\"ur die Aufbereitung und Versendung aller Nachrichten
  an den SoccerServer zust\"andig.
 
  {\small {\bf Quelltext}

  [\URL[Header]{src/EffectorsServer.h} | [\URL[Implementierung]{src/EffectorsServer.cc}]

  {\bf CVS Informationen zum Interface}
  \begin{verbatim}
  **************************************************
  *
  * Aktueller Stand
  *
  *   $RCSfile: EffectorsServer.h,v $
  *   $Revision: 1.2 $
  *   $Date: 2001/06/18 15:41:15 $
  *   $Author: wendler $ 
  *
  **************************************************
  \end{verbatim} }*/
class EffectorsServer : public Effectors
{
public:
  
  /** Erzeugt ein neues Effectors-Objekt. 
      @param aCommunicator Der Communicator, ueber den die Effektoren die
      Aktionen verschickt. */
  EffectorsServer( Communicator* aCommunicator );

  ~EffectorsServer();

  /** Anmeldung auf dem Spielfeld. */
  virtual void enterField( const Ath98String& aTeamName ) const;

  /** Schickt das Kommando zum Oeffnen der Augen an den SoccerServer. */
  virtual void openEyes() const;

  /** Schickt das Kommando, dass der Spieler mit der Nummer playerNum
      durch einen Spieler des Types type ausgetauscht wird. */
  virtual void changePlayerType(int playerNum, int type ) const;

  /** Sendet einen Ruf der in der Coach-Language verfasst sein sollte. */
  virtual void sayMessage( const Ath98String& message ) const;

private:
  /** Pointer auf den Communicator des Agenten. */
  Communicator *theCommunicator;

};

#endif
