#include "InitialScanIntention.h"

#include "../conditions/WorldModelStatesConditions.h"
#include "../../worldmodel/Neck.h"


InitialScanIntention::InitialScanIntention() : Intention( theId ){
  addPreCondition( new TrueCondition );
  addBreakCondition( new GameStateCondition( WorldModelInterface::KICK_OFF |
 											 WorldModelInterface::PLAY_ON ) );
  addPostCondition( new GameStateCondition( WorldModelInterface::KICK_OFF |
 											 WorldModelInterface::PLAY_ON ) );
  calculateIntentionOrder();
}

Action InitialScanIntention::execute(){
  INFO( Log::INTENTIONS  ,  6  ,  idString() , globalLog->infoStream
    << "ENTER " << idString() << "::execute\n" );

  if( globalWorldModel->simStep() >= globalWorldModel->simStepOfLastSee() ){
    switch (theIsFirstExecute) {
    case 1:
      globalNeck->setNeckBehaviour( NECK_TO_LEFT, ALIGN_CENTER, VERY_HIGH_PRIORITY );
      globalNeck->setViewBehaviour( VIEW_WIDTH_WIDE, VIEW_QUALITY_HIGH, VERY_HIGH_PRIORITY );
      theIsFirstExecute = 2;
      break;
    case 2:
      globalNeck->setNeckBehaviour( NECK_TO_RIGHT, ALIGN_CENTER, VERY_HIGH_PRIORITY );
      globalNeck->setViewBehaviour( VIEW_WIDTH_WIDE, VIEW_QUALITY_HIGH, VERY_HIGH_PRIORITY );
      theIsFirstExecute = 1;
      break;
    default:
     break;  
    }
  }
  return Action( EMPTY_ACTION, globalWorldModel->simStep() );
} 