#ifndef _INITIAL_SCAN_INTENTION_H_
#define _INITIAL_SCAN_INTENTION_H_

#include "../Intention.h"
#include "../basicIntentions/WaitIntention.h"

/** Aufgabe der InitialScanIntention ist es vor dem Anstoss das Feld zu scannen,
 um Infomationen zu sammeln. */

class InitialScanIntention : public Intention {
 public:
  static const IntentionId theId = 32;

  /** Konstruktoren. */
  InitialScanIntention();
   
  Action execute();

 private: 
  void calculateIntentionOrder();
  /** Flag, das anzeigt, ob der erste Durchlauf ansteht. */
  int theIsFirstExecute;
  /** Der Simstep, an dem die erste Nackendrehung berechnet wurde. Diese Step wird gemerkt,
      damit nach der uebernaechsten See-Info eine Drehung nach hinten gemacht werden kann. */
  int theStepOfCalcFirstTurn;
};

inline void InitialScanIntention::calculateIntentionOrder(){
  theIsFirstExecute = 1;
}

#endif