#include "KickIntention.h"

#include "../conditions/KickConditions.h"
#include "../skills/Skills.h"
#include "../../worldmodel/Neck.h"


KickIntention::KickIntention( const Target& aTarget, double aDesiredSpeed = globalConf->ballSpeedMax, int aMaxSteps = 1 ) :
  BasicIntention( theId, aTarget ), theTargetId( UNDEF_INT ), theDesiredSpeed( aDesiredSpeed ) , theMaxSteps(aMaxSteps)
{
  addPreCondition( new KickPossibleCondition() );
  addPostCondition( new KickImpossibleCondition() );
}

Action KickIntention::execute() {
//cerr << "KICKINTENTION::TARGET  : " << target().pos() << endl;

  theTarget.setPos( target().pos() );
 
  globalSkills->resetSituation();
  Action anAction;
  anAction = globalSkills->kick( target().pos(), theDesiredSpeed, theMaxSteps );

  return anAction;
}
