#include "MoveIntention.h"

#include "../conditions/WorldModelStatesConditions.h"
#include "../conditions/PositionConditions.h"
#include "../../basic/Action.h"
#include "../../worldmodel/WorldModelInterface.h"

MoveIntention::MoveIntention() :
  BasicIntention( theId ) {
  addPreCondition( new GameStateCondition( WorldModelInterface::BEFORE_KICK_OFF |
					   WorldModelInterface::GOAL ) );
  
  addPostCondition( new PositionCondition( Target( globalWorldModel->basePosition() ) ) );
  setTarget( globalWorldModel->basePosition() );
}

MoveIntention::MoveIntention( const Target& aTarget ) :
  BasicIntention( theId, aTarget ){
    addPreCondition( new GameStateCondition( WorldModelInterface::BEFORE_KICK_OFF |
					   WorldModelInterface::GOAL ) );

  addPostCondition( new PositionCondition( aTarget ) );
}

Action MoveIntention::execute() {
  INFO( Log::INTENTIONS,  10,  idString() , globalLog->infoStream << 
	idString() <<	"::execute\n");
  
  return Action( MOVE_ACTION, globalWorldModel->simStep(), target().pos().x(), target().pos().y() );
}
