#include "PMoveIntention.h"

#include "../conditions/WorldModelStatesConditions.h"
#include "../conditions/PositionConditions.h"
#include "../../basic/Action.h"
#include "../../basic/Formation.h"
#include "../../worldmodel/WorldModelInterface.h"

PMoveIntention::PMoveIntention() :
  BasicIntention( theId ) {

  // Target bestimmen
  Vector position;
  if ( globalFormation->formationGetPosition( globalWorldModel->playerNumber() ).x() < 0.0 )
    position = globalFormation->formationGetPosition( globalWorldModel->playerNumber() );
  else
    position = Vector( -1.0, globalFormation->formationGetPosition( globalWorldModel->playerNumber() ).y() );

  // Target setzen
  setTarget( position );

  addPreCondition( new GameStateCondition( WorldModelInterface::BEFORE_KICK_OFF |
					   WorldModelInterface::GOAL ) );

  addPostCondition(
       new OrCondition( new GameStateCondition( ~( WorldModelInterface::BEFORE_KICK_OFF |
						  WorldModelInterface::GOAL ) ),
		       new PositionCondition( Target( position ) ) ) );
}

PMoveIntention::PMoveIntention( const Target& aTarget ) :
  BasicIntention( theId, aTarget ){
    addPreCondition( new GameStateCondition( WorldModelInterface::BEFORE_KICK_OFF |
					   WorldModelInterface::GOAL ) );

  addPostCondition(
       new OrCondition( new GameStateCondition( ~( WorldModelInterface::BEFORE_KICK_OFF |
						  WorldModelInterface::GOAL ) ),
		       new PositionCondition( Target( globalWorldModel->
						      basePosition() ) ) ) );
}

Action PMoveIntention::execute() {
  INFO( Log::INTENTIONS,  10,  idString() , globalLog->infoStream <<
	idString() <<	"::execute\n");

  return Action( MOVE_ACTION, globalWorldModel->simStep(),
    		 target().pos().x(),
		 target().pos().y() );
}
