#ifndef _WAIT_INTENTION_H_
#define _WAIT_INTENTION_H_

#include "BasicIntention.h"

class WaitIntention : public BasicIntention {
 public:
  static const IntentionId theId = 8;
  // bestimmte Zahl von Simsteps  warten
  WaitIntention( int aTime = 1 );
  // warten bis WaitCondition.check() TRUE liefert
  // WaitIntention( Condition* aWaitCondition );
  WaitIntention( Condition* aCondition );

/*
  // Diese spezielle Waitintention ist immer dann sinnvoll, wenn in einer Intention eine feste Folge von Sichten garantiert werden soll.
  // Bsp: GoalieKickIntention
  // erst wide gucken und auf Sichtinfos warten, dann narrow auf das KickTarget schauen und auf Sichtinfos warten
  WaitIntention( int aTime//,
//                 int desiredNeckBehaviour,// = NECK_IN_FRONT,
//                 int desiredNeckBehaviourAlignment,// = ALIGN_CENTER,
//                 int desiredNeckBehaviourPriority,// = VERY_LOW_PRIORITY,
//                 int desiredViewWidth,// = VIEW_WIDTH_NORMAL,
//                 int desiredViewQuality,// = VIEW_QUALITY_HIGH,
//                 int desiredViewPriority// = VERY_LOW_PRIORITY 
               );
*/
  Action execute();

private:
  bool changeViewBehaviour;
  int theDesiredNeckBehaviour;
  int theDesiredNeckBehaviourAlignment;
  int theDesiredNeckBehaviourPriority;
  int theDesiredViewWidth;
  int theDesiredViewQuality;
  int theDesiredViewPriority;  
};

#endif
