#include "DribbleIntention.h"

#include "../conditions/KickConditions.h"
#include "../conditions/PlayerDependentConditions.h"
#include "../conditions/PassConditions.h"
#include "../conditions/PositionConditions.h"
#include "../conditions/LostBallCondition.h"

#include "../skills/Skills.h"

#include "../../analyzer/Analyzer.h"
#include "../../worldmodel/WorldModelInterface.h"


DribbleIntention::DribbleIntention() : Intention( theId ){

  addPreCondition( new StaminaCondition( globalConf->dribbleStaminaLimit ) );

  addPostCondition( new PositionCondition( Target( Target::DRIBBLE ), 0.5 ) );

  addBreakCondition( new LostBallCondition() );
  addBreakCondition( new LooseBallCondition() );
  addBreakCondition( new PassPossibleCondition() );
  addBreakCondition( new ScoreGoalPossibleCondition() );
  addBreakCondition( new RiskScoreGoalPossibleCondition() );
}


Action DribbleIntention::execute(){
  INFO( Log::INTENTIONS,  6,  idString() , globalLog->infoStream
    << "ENTER " << idString() << "::execute()\n");

  globalSkills->resetSituation();
  return globalSkills->dribble( Target(Target::DRIBBLE).pos() );  

  INFO( Log::INTENTIONS,  10,  idString() , globalLog->infoStream
    << "LEAVE " << idString() << "::execute()\n" );
}
