#include "GetBallIntention.h"

#include "../basicIntentions/GoToIntention.h"

#include "../conditions/Condition.h"
#include "../conditions/ConfidenceCondition.h"
#include "../conditions/KickConditions.h"
#include "../conditions/WorldModelStatesConditions.h"

#include "../goalieIntentions/GoalieConditions.h"

#include "../../worldmodel/WorldModelInterface.h"


GetBallIntention::GetBallIntention( double aDesiredMaxPower ) :
  Intention( theId, Target( Target::BALL ) ), theDesiredMaxPower( aDesiredMaxPower )
{
  addPreCondition( new KickImpossibleCondition() );
//   addPreCondition( new OrCondition( new GoalieInterceptCondition(),new InterceptCondition(InterceptCondition::ONE) ) );
  addPreCondition( new ConfidenceCondition( BALL_ID, 0.4 ) ); // siehe HACK in StandardGoalieRole u. Neck

  addBreakCondition( new GameStateCondition( WorldModelInterface::PLAY_ON ) );

  addPostCondition( new KickPossibleCondition() );
  calculateIntentionOrder();
}



void GetBallIntention::calculateIntentionOrder() {
  INFO( Log::INTENTIONS,  10,  idString() , globalLog->infoStream << idString() << "::calculateIntentionOrder \n");

  theIntentions.push_back( new GoToIntention( Target( Target::BALL ), theDesiredMaxPower, globalConf->interceptBallStaminaLimit ) );

  current = theIntentions.begin();
}
