#include "PPositionIntention2.h"

#include "../basicIntentions/TurnIntention.h"
#include "../basicIntentions/GoToIntention.h"

#include "../conditions/KickConditions.h"
#include "../conditions/InterceptCondition.h"
#include "../conditions/PlayerDependentConditions.h"
#include "../conditions/PositionConditions.h"

#include "../../worldmodel/Neck.h"


PPositionIntention2::PPositionIntention2() : Intention( theId ){
  addPreCondition( new OffensivePositionCondition() );

  addBreakCondition( new KickPossibleCondition() );
  addBreakCondition( new InterceptCondition( InterceptCondition::SMART ) );

  addPostCondition( new PositionCondition( Target( Target::COVER ), 0.4 ) );
  addPostCondition( new BodyDirectionCondition( Target( Target::BALL ) ) );
  calculateIntentionOrder();
}

Action PPositionIntention2::execute(){

  globalNeck->setViewBehaviour( VIEW_WIDTH_WIDE, VIEW_QUALITY_HIGH, HIGH_PRIORITY );
  globalNeck->setNeckBehaviour( NECK_TO_BALL, ALIGN_CENTER, HIGH_PRIORITY );

  return Intention::execute();
}

void PPositionIntention2::calculateIntentionOrder(){
  addIntention( new GoToIntention( Target( Target::COVER ), 100.0, globalConf->positioningStaminaLimit ) ); // PPositionierung
  addIntention( new TurnIntention( Target( Target::BALL ) ) );

  current = theIntentions.begin();
}
