#include "PassIntention.h"

#include "DribbleIntention.h"

#include "../basicIntentions/DummyIntention.h"
#include "../basicIntentions/KickIntention.h"

#include "../conditions/KickConditions.h"
#include "../conditions/PassConditions.h"
#include "../conditions/AttackConditions.h"

#include "../../basic/Timer.h"

PassIntention::PassIntention() :
  Intention( theId ) {
  addPreCondition( new KickPossibleCondition() );
  addPreCondition( new PassPossibleCondition() );

  addPostCondition( new KickImpossibleCondition() );

  calculateIntentionOrder();
}

PassIntention::PassIntention( bool risky ) :
  Intention( theId ) {
  addPreCondition( new KickPossibleCondition() );
  addPreCondition( new RiskPassPossibleCondition() );

  addPostCondition( new KickImpossibleCondition() );

  calculateIntentionOrder();
}

void PassIntention::calculateIntentionOrder(){
  INFO( Log::INTENTIONS, 10, idString(), globalLog->infoStream << idString() << "::calculateIntentionOrder\n");

  theIntentions.push_back( new KickIntention( Target(Target::PASS), 1.2, 3 ) );
  current = theIntentions.begin();
}

