#include "ScanFieldIntention.h"

#include "../conditions/ConfidenceCondition.h"

#include "../../worldmodel/Neck.h"
#include "../../worldmodel/WorldModelInterface.h"


ScanFieldIntention::ScanFieldIntention() :
  Intention( theId ){
  addPostCondition( new ConfidenceCondition( BALL_ID, 0.8 ) );

  addPreCondition( new TrueCondition );

  calculateIntentionOrder();
}

ScanFieldIntention::ScanFieldIntention( const double reliability ) :
  Intention( theId ){
  addPostCondition( new ConfidenceCondition( BALL_ID, reliability ) );

  addPreCondition( new TrueCondition );

  calculateIntentionOrder();
}


Action ScanFieldIntention::execute(){
  INFO( Log::INTENTIONS  ,  6  ,  idString() , globalLog->infoStream
    << "ENTER " << idString() << "::execute\n" );

  int theSimStep = globalWorldModel->simStep();
  int seeStep = globalWorldModel->simStepOfLastSee();
/*
cout << endl << theSimStep <<" ScanFieldIntention::execute()\n";
cout << "theSimStepOfEnterScanField = " << theSimStepOfEnterScanField << endl;
cout << "  simStepOfLastSee = " << seeStep << endl;
cout << "  simStepOfLastMichaelsError = " << globalWorldModel->simStepOfLastMichaelsError() << endl;
cout << "  theExecuteStep = " << theExecuteStep << endl;
*/
  if( globalWorldModel->getAgentTimeOfLastSeeInfo() > agentTimeOfLastStateChange) {
    switch (theExecuteStep) {
      case 1: // v.a. wichtig frs debuggen / im Spiel eher unerheblich
        theExecuteStep = 2;
        break;
      case 2:
        theExecuteStep = 3;
        break;  
      case 3:
       theExecuteStep = 4;
       break;  
      case 4:
        theExecuteStep = 3;
        break;
      default:
         break;  
    }
    agentTimeOfLastStateChange = globalTimer->getAgentTime();
    theSimStepOfLastStateChange = theSimStep;
  }

  switch (theExecuteStep) {
    case 1: // v.a. wichtig frs debuggen / im Spiel eher unerheblich
//      globalNeck->setNeckBehaviour( NECK_IN_FRONT, ALIGN_CENTER, VERY_HIGH_PRIORITY );
      globalNeck->setViewBehaviour( VIEW_WIDTH_WIDE, VIEW_QUALITY_HIGH, VERY_HIGH_PRIORITY );
      break;
    case 2:
      globalNeck->setNeckBehaviour( NECK_TO_RIGHT, ALIGN_CENTER, VERY_HIGH_PRIORITY );
      globalNeck->setViewBehaviour( VIEW_WIDTH_WIDE, VIEW_QUALITY_HIGH, VERY_HIGH_PRIORITY );
      break;
    case 3:
      globalNeck->setNeckBehaviour( NECK_TO_LEFT, ALIGN_CENTER, VERY_HIGH_PRIORITY );
      globalNeck->setViewBehaviour( VIEW_WIDTH_WIDE, VIEW_QUALITY_HIGH, VERY_HIGH_PRIORITY );
      break;
    case 4:
      globalNeck->setNeckBehaviour( NECK_TO_RIGHT, ALIGN_CENTER, VERY_HIGH_PRIORITY );
      globalNeck->setViewBehaviour( VIEW_WIDTH_WIDE, VIEW_QUALITY_HIGH, VERY_HIGH_PRIORITY );
      if( theSimStepOfLastStateChange == theSimStep ) {
      	return Action( TURN_ACTION, globalWorldModel->simStep(), normalizeAngle( radFromDegree( -20 ) ) );
      }
      break;
    default:
      break;  
  }
/*
cout << "  theNewExecuteStep = " << theExecuteStep << endl;
cout << "end ScanFieldIntention::execute()\n";
*/  
  return Action( EMPTY_ACTION, globalWorldModel->simStep() );
}