#include "Condition.h"
#include "../../analyzer/Analyzer.h"
#include "../../basic/Configuration.h"

#include <iomanip>

Condition::Condition() :
  theFlag( false ) {}

Condition::Condition( bool falseOrTrue ) :
  theFlag( falseOrTrue ) {}

Condition::~Condition(){}

bool Condition::check() const{
  return theFlag;
}

OrCondition::OrCondition( Condition* firstCond,
			  Condition* secondCond ) :
  Condition(),
  firstCondition( firstCond ),
  secondCondition( secondCond ) {}

OrCondition::~OrCondition(){
  delete firstCondition;
  delete secondCondition;
}

AndCondition::AndCondition( Condition* firstCond,
			  Condition* secondCond ) :
  Condition(),
  firstCondition( firstCond ),
  secondCondition( secondCond ) {}

AndCondition::~AndCondition(){
  delete firstCondition;
  delete secondCondition;
}


NotCondition::NotCondition( Condition* firstCond  ) :
  Condition(),
  firstCondition( firstCond ) {}

NotCondition::~NotCondition(){
  delete firstCondition;
}

TrueCondition::TrueCondition(): Condition(){}

FalseCondition::FalseCondition(): Condition(){}



