#include "InterceptCondition.h"

#include "../../analyzer/Analyzer.h"
#include "../../worldmodel/WorldModelInterface.h"


InterceptCondition::InterceptCondition( InterceptBehavior aBehavior ) :
  Condition(), theBehavior( aBehavior ),
  theSimstep( globalWorldModel->simStep() ){}

bool InterceptCondition::check() const{

  INFO( Log::CONDITIONS , 6 , "" , globalLog->infoStream << "InterceptCondition::check\n" );

  int myStepsToBall = globalAnalyzer->getMyStepsToBall();
  int ourStepsToBall = globalAnalyzer->getNearestTeammateStepsToBall();
  int our2ndStepsToBall = globalAnalyzer->get2ndNearestTeammateStepsToBall();
  int ourGoalieStepsToBall = globalAnalyzer->getOurGoalieStepsToBall();
//  int theirStepsToBall = globalAnalyzer->getNearestEnemyStepsToBall();

  Situation situation = globalWorldModel->situation();
/*
cout << "    myStepsToBall                  : " << myStepsToBall << endl;
cout << "    ourGoalieStepsToBall           : " << ourGoalieStepsToBall << endl;
cout << "    nearestTeammateStepsToBall     : " << ourStepsToBall << endl;
cout << "    nearestTeammateStepsToBall(s)  : " << situation.getNearestTeammateSteps() << endl;
cout << "    nearestTeammate                : " << situation.index2Id(situation.indexOfNearestPlayer(OUR_TEAM_ID)) << endl;
cout << "    2.nearestTeammateStepsToBall   : " << our2ndStepsToBall << endl;
cout << "    2.nearestTeammateStepsToBall(s): " << situation.getSecondNearestTeammateSteps() << endl;
cout << "    2.nearestTeammate              : " << situation.index2Id(situation.indexOfSecondNearestTeammate()) << endl;  // hat schon ein anderer Mitspieler den Ball sicher, brauchen wir nicht hin
*/



 switch( theBehavior ) {
    case ONE:
      if( myStepsToBall > ourStepsToBall ) {
            return NO;
      }
      else{
        return YES;
      }         
      break;

    case TWO:
      if( myStepsToBall > our2ndStepsToBall + 2  ) {
        return NO;
      }
      else{
        return YES;
      }
      break;

    case SMART:
    	if( ourGoalieStepsToBall < 3  ) {
    	  return NO;
    	}
     	else if( myStepsToBall > ourStepsToBall + ceil( log( 2 * myStepsToBall + 1 ) ) ) {
        return NO;
     	}
    	else{
     	  return YES;
     	}
      break;
    default:
      return YES;
  }
  return YES;
}
