#ifndef _INTERCEPT_CONDITION_H_
#define _INTERCEPT_CONDITION_H_

#include "Condition.h"

class InterceptCondition : public Condition{
 public:
/** @name InterceptBehavior
      Kodierung unterschiedlicher Verhaltensweisen beim Intercept:
      ONE: nur der n\"achste Spieler geht zum Ball
      TWO: die zwei n\"achsten Spieler gehen zum Ball
      THREE: die drei n\"achsten Spieler gehen zum Ball
      ALL: die versuchen den Ball zu bekommen
      OFFENSIV: der/die Spieler versuchen den Ball mglichst in Richtung
      gegnerisches Tor zu bekommen
  */
  static const short int ONE = 1;
  static const short int TWO = ONE<<2;
  static const short int SMART = TWO<<4; // SEATTLE


  /** Namensgebung f\"ur InterceptBehavior. */
  typedef short int  InterceptBehavior;

  InterceptCondition( InterceptBehavior aBehavior = TWO );
  
  bool check() const;
  void prepareSituation() const;

 private:
  InterceptBehavior theBehavior;
  int theSimstep;
  //  Target theTarget;
};

#endif
