#ifndef _LOST_BALL_CONDITION_H_
#define _LOST_BALL_CONDITION_H_

#include "Condition.h"
#include "../../analyzer/Analyzer.h"
#include "../../worldmodel/WorldModelInterface.h"

class LostBallCondition : public Condition
{
 public:
  LostBallCondition();
  
  bool check() const;
};

inline bool LostBallCondition::check() const{

  const ModelledPlayer& mySelf = globalWorldModel->player();
  const ModelledBall& ball = globalWorldModel->ball();
  
  return ( ( globalAnalyzer->getNearestEnemyStepsToBall() < globalAnalyzer->getMyStepsToBall() )
           || ( (globalAnalyzer->getNearestTeammateStepsToBall() < globalAnalyzer->getMyStepsToBall())
                && (mySelf.distTo( ball.pos() ) < mySelf.kickRange()) )
           || ( globalWorldModel->player().distTo(globalWorldModel->ball().pos()) > 5.0 ) );
}


class LooseBallCondition : public Condition
{
 public:
  LooseBallCondition();
  
  bool check() const;
};

inline bool LooseBallCondition::check() const{
	     
  return (  (globalAnalyzer->getNearestEnemyStepsToBall() < globalAnalyzer->getMyStepsToBall() + 1)
            || ( globalWorldModel->player().pos().x() < -30.0 )  );
}


#endif
