#include "NearestConditions.h"

NearestPlayerToBallCondition::NearestPlayerToBallCondition() :
  Condition() {}

bool NearestPlayerToBallCondition::check() const{
  const Situation& theSituation = globalWorldModel->situation();
  if ( theSituation.playerWithIndex( theSituation.indexOfNearestPlayerToPos(
          globalWorldModel->ball().pos()) ).id() == globalWorldModel->id() ) {
    return true;
  }
  return false;
}

NotNearestPlayerToBallCondition::NotNearestPlayerToBallCondition() : 
  NearestPlayerToBallCondition() {}

NearestPlayerCondition::NearestPlayerCondition( const Target& aTarget ):
  Condition(), theTarget( aTarget ) {}

bool NearestPlayerCondition::check() const{
  return ( globalWorldModel->id() ==
	   globalWorldModel->situation().index2Id( 
	         globalWorldModel->situation().indexOfNearestPlayerToPos( theTarget.pos() ) ) );
}
