#include "PlayerDependentConditions.h"

StaminaCondition::StaminaCondition() :
  Condition(), theLimit( globalConf->conserveStaminaActivation ) {}

StaminaCondition::StaminaCondition( unsigned int aLimit ) :
  Condition(), theLimit( aLimit ) {}

bool StaminaCondition::check() const{
  INFO( Log::CONDITIONS  ,  6  ,  "" , globalLog->infoStream <<	"StaminaCondition::check\n" );
  INFO( Log::CONDITIONS  ,  10  ,  "" , globalLog->infoStream << "limit: " << theLimit 
    << " player stamina: " << globalWorldModel->player().stamina() << endl );
  return globalWorldModel->player().stamina() > theLimit;
}

BodyDirectionCondition::BodyDirectionCondition( const Target& aTarget ) :
  Condition(), theTarget( aTarget ) {}
