#ifndef _PLAYER_DEPENDENT_CONDITIONS_H_
#define _PLAYER_DEPENDENT_CONDITIONS_H_

#include "Condition.h"

#include "../targets/Target.h"
#include "../../worldmodel/ModelledPlayer.h"

class StaminaCondition : public Condition{
 public:
  StaminaCondition();
  StaminaCondition( unsigned int aLimit );

  void setLimit( unsigned int aLimit );
  unsigned int limit() const;
  
  bool check() const;
  
 private:
  unsigned int theLimit;
};

inline void StaminaCondition::setLimit( unsigned int aLimit ){
  theLimit = aLimit;
}

inline unsigned int StaminaCondition::limit() const{
  return theLimit;
}

class BodyDirectionCondition : public Condition{
 public:
  BodyDirectionCondition( const Target& aTarget );
  
  bool check() const;
 private:
  Target theTarget;
};

inline bool BodyDirectionCondition::check() const{
  INFO( Log::CONDITIONS,  6,  idString() , globalLog->infoStream << "BodyDirectionCondition::check\n" );
  return ( Ath98_PI - fabs( Ath98_PI - globalWorldModel->player().angleOfBodyTo( theTarget.pos() ) ) < Ath98_PI_5_DEGREE );
}

#endif
