#include "PositionConditions.h"

#include "../../analyzer/Analyzer.h"

PositionCondition::PositionCondition( const Target& aTarget, double aTargetMargin ) :
  Condition(), theTarget( aTarget ), theTargetMargin(aTargetMargin) {}

bool PositionCondition::check() const{
  INFO( Log::INTENTIONS, 6, "PositionCondition ", globalLog->infoStream << "check with : " << theTarget.pos() << endl );

  // cout << " PositionCondition theTarget = " << theTarget.pos() << endl;
  // cout << " PositionCondition myPos = " << globalWorldModel->player().pos() << endl;

  double dist = globalWorldModel->player().distTo( theTarget.pos() );
 	
  if( globalWorldModel->player().distTo( theTarget.pos() ) < theTargetMargin ) {
	  //	cout << " -> return TRUE   ( " << dist << " , " << theTargetMargin << " )\n";
   	return YES;	
 	}
	   // cout << " -> return FALSE   ( " << dist << " , " << theTargetMargin << " )\n";
	return NO;
}



OffensivePositionCondition::OffensivePositionCondition() :
  Condition() {}


bool OffensivePositionCondition::check() const {
  if(  ( ( min(globalAnalyzer->getNearestTeammateStepsToBall(), globalAnalyzer->getMyStepsToBall()) < globalAnalyzer->getNearestEnemyStepsToBall() - 3 )
          && (globalWorldModel->ball().pos().x() > -10.0) )
     || (globalWorldModel->ball().pos().x() > 0.0 )  ) {
    return YES;
  }
  return NO;
}
