#include "WaitAndTimeConditions.h"

#include "../../worldmodel/WorldModelInterface.h"

//int WaitUntilCondition::theStepOfFirstCheck = UNDEF_INT;


WaitUntilCondition::WaitUntilCondition( int aSimStep ) :
  Condition(), thePlayerId( UNDEF_INT ), thePos( Vector() ),
  theSimStepToContinue( aSimStep ),
  theStepOfFirstCheck( UNDEF_INT){}
						
 
WaitUntilCondition::WaitUntilCondition( int aPlayerId,
					const Vector aPos,
					int aSimStep ) :
  Condition(), thePlayerId( aPlayerId ), thePos( aPos ),
  theSimStepToContinue ( aSimStep ),
  theStepOfFirstCheck( UNDEF_INT){}


// Bedingung wird wahr, wenn ein Spieler unseres Teams eine Position erreicht hat, 
// oder eine Zeitschranke  ueberschritten ist

bool WaitUntilCondition::check() const{
 INFO( Log::CONDITIONS  ,  6  ,  "" , globalLog->infoStream <<
       "WaitUntilCondition::check() : theSimstep : " << theSimStepToContinue 
       << ": gwm->simstep : " <<  globalWorldModel->simStep() << "\n");

  if( theStepOfFirstCheck == UNDEF_INT ){
    theStepOfFirstCheck = globalWorldModel->simStep();
  }

  if(theStepOfFirstCheck + theSimStepToContinue > globalWorldModel->simStep())
  {
    return NO;
  }
  
  return YES;
}


bool WaitUntilCondition::isOurTeamNearPosition() const{
  const Situation situation( globalWorldModel->situation() );

  int myIndex = situation.id2Index( globalWorldModel->id() );
  double minDist = DBL_MAX;
  int index = UNDEF_INT;

  for ( int i = 0;  i < situation.playerCount();  ++i ) {
    if( i == myIndex ) continue;
    if( situation.playerWithIndex( i ).team() == OUR_TEAM_ID ){
      double dist = situation.playerWithIndex( i ).distTo( thePos );
      if( minDist > dist ){
	index = i;
	minDist = dist;
      }
    }
  }
  if( index != UNDEF_INT && minDist < globalConf->interceptBallAccuracy ){
    return true;
  }
  return false;
}

