#ifndef _WAIT_AND_TIME_CONDITIONS_H_
#define _WAIT_AND_TIME_CONDITIONS_H_

#include "Condition.h"

#include "../../basic/Vector.h"

class WaitUntilCondition : public Condition{
 public:

  static const int ALL_OUR_PLAYERS = OUR_TEAM_ID;

  WaitUntilCondition( int aTime );
  WaitUntilCondition( int aPlayerId, const Vector aPos, int simStep = 20 );
  
  bool check() const;

 protected:
  int thePlayerId;
  Vector thePos;
  int theSimStepToContinue;
  bool isOurTeamNearPosition() const;
  mutable int theStepOfFirstCheck;
};

class TimeStepCondition : public Condition{
 public:
  TimeStepCondition( int steps );
  bool check();
 protected:
  int theSteps;
};


#endif
