#ifndef _WORLDMODEL_STATES_CONDITIONS_H_
#define _WORLDMODEL_STATES_CONDITIONS_H_

#include "Condition.h"

#include "../../worldmodel/WorldModelInterface.h"

#include "../../analyzer/Analyzer.h"

class InitiativeCondition : public Condition
{
 public:
    InitiativeCondition( int aTeam );
    
    void set( int aTeam );
    int get() const;
  
    bool check() const;
 private:
    int theTeam;
};

inline void InitiativeCondition::set( int aTeam )
{
    theTeam = aTeam;
}

inline int InitiativeCondition::get() const
{
    return theTeam;
}

inline bool InitiativeCondition::check() const{
  INFO( Log::CONDITIONS  ,  10  ,  "" ,
	globalLog->infoStream << "InitiativeCondition::check\n" );
/*   INFO( Log::CONDITIONS  ,  10  ,  "" , */
/* 	globalLog->infoStream << "initiative==" << globalWorldModel->initiative() << '\n' ); */
  return globalWorldModel->initiative() == theTeam;
}

class GameStateChangeCondition : public Condition{
 public:
  GameStateChangeCondition() : Condition() {}
  bool check() const;
};

inline bool GameStateChangeCondition::check() const{
  return globalAnalyzer->classifySituation() & Analyzer::GAME_STATE_CHANGE;
}

class GameStateCondition : public Condition {
 public:

  static const long anyGameState = 0xffffffff;

  GameStateCondition();
  GameStateCondition( long someGameStates );

  void setGamestates( long someGameStates );
  long gameStates() const;

  bool check() const;

 private:
  long theGameStates;
};



inline void GameStateCondition::setGamestates( long someGameStates ){
  theGameStates = someGameStates;
}

inline long GameStateCondition::gameStates() const{
  return theGameStates;
}

#endif
