#include "GoalieInterceptIntention.h"

#include "GoalieConditions.h"

#include "../basicIntentions/GoToIntention.h"
#include "../basicIntentions/DummyIntention.h"

#include "../conditions/KickConditions.h"
#include "../conditions/WorldModelStatesConditions.h"

#include "../targets/Target.h"

#include "../skills/Skills.h"

#include "../../worldmodel/Neck.h"

#include "../../analyzer/Analyzer.h"


GoalieInterceptIntention::GoalieInterceptIntention( GoalieInterceptBehaviour aBehaviour ) :
  Intention( theId ), theBehaviour( aBehaviour ){
  
  addPreCondition( new GoalieInterceptCondition( aBehaviour ) );
  addPreCondition( new NotCondition ( new GameStateCondition( WorldModelInterface::FREE_KICK ) ) );
  // Ball ausserhalb CatchArea ?
  addBreakCondition( new CatchCondition() );
  
  addPostCondition( new OrCondition ( new KickPossibleCondition(), new CatchCondition() ) );

  calculateIntentionOrder();
}

Action GoalieInterceptIntention::execute() {
  INFO( Log::INTENTIONS  ,  6  ,  idString() , globalLog->infoStream
    << " ENTER " << idString() << "::execute\n" );
/*
cout << endl << "GoalieInterceptIntention::execute()\n";
cout << "BALL : " << globalWorldModel->ball() << endl;
cout << "ICH  : " << globalWorldModel->player() << endl;
cout << "-> Goalie Intercept Target : " << Target(Target::GOALIE_INTERCEPT_POSITION).pos() << endl;
*/
  globalNeck->setNeckBehaviour( NECK_TO_BALL );
  globalNeck->setViewBehaviour( VIEW_WIDTH_NARROW, VIEW_QUALITY_HIGH,  VERY_HIGH_PRIORITY);

  return Intention::execute();
}  

void GoalieInterceptIntention::calculateIntentionOrder() {
  INFO( Log::INTENTIONS  ,  6  ,  idString() , globalLog->infoStream
    << " ENTER " << idString() << "::calculate \n" );  
 
  addIntention( new GoToIntention ( Target(Target::GOALIE_INTERCEPT_POSITION),
                                    globalConf->maxPower,
                                    globalConf->goalieInterceptBallStaminaLimit,
                                    globalAnalyzer->getGoalieInterceptRunBehaviour() ) );
  current = theIntentions.begin(); 
}
