 
/* 
 * Aktueller Stand 
 * 
 *   $RCSfile: ExceptionTestAgent.cc,v $ 
 *   $Revision: 1.1.1.1 $ 
 *   $Date: 2001/07/31 22:23:09 $ 
 *   $Author: rami $  
 * 
 */ 
  
#include "Common.h" 
#include "Exception.h" 
#include "InvalidIdException.h" 
#include <iostream.h> 
 
class MyEx:  public Exception  
{ 
public: 
  MyEx(const Ath98String& aDescription ) 
    : Exception( aDescription ) {} 
};  
 
void sub2();  
 
void sub1() 
{ 
  cout << "sub1 ENTER" << endl;  
  try { 
    sub2();  
  } 
  catch (Exception e) { 
    cout << e << endl;  
  } 
  cout << "sub1 LEAVE" << endl;  
} 
 
void sub2()  
{ 
  cout << "sub2 ENTER" << endl;  
  throwException( MyEx("Eine Beschreibung") );  
  cout << "sub2 LEAVE" << endl;  
} 
 
class SimpleException 
{ 
};  
 
int main()  
{ 
  cout << endl << "0. Testing simplest possible exception throw and catch";  
  cout << endl;  
  try { 
    throw SimpleException();  
  } 
  catch ( SimpleException ) { 
    cout << "SimpleException caught." << endl;  
  } 
   
   
  cout << endl << "1. Testing catch of Exception without description";  
  cout << endl;    
  try { 
    throwException( Exception() );  
  } 
  catch (Exception e) { 
    cout << e << endl;  
  } 
 
  cout << endl << "2. Testing catch of Exception" << endl;    
  try { 
    sub2();  
  } 
  catch ( MyEx a ) { 
    cout << "In 1. catch" << endl;  
    cout << a << endl;  
  } 
 
  cout << endl << "3. Testing catch of (...)" << endl;    
  try { 
    sub2();  
  }  
  catch (...) { 
    cout << "Some Exception caught." << endl;  
  } 
   
  cout << endl << "4. Testing catch of InvalidIdException" << endl;    
  try { 
    sub2();  
  } 
  catch (MyEx e) { 
    cout << e << endl;  
    cout << "Description of exception: " << e.description() << endl;  
  } 
   
  cout << endl << "5. Testing catch in subroutine" << endl;    
  sub1();  
   
  cout << "Testing direct catch of InvalidIdException";  
  cout << endl;    
  try { 
    throwException( InvalidIdException( "Direct throwException" ) );  
  } 
  catch (InvalidIdException e) { 
    cout << e << endl;  
  } 
 
   
  cout << "Done." << endl;  
  return 0;  
}   
   
;  
